image: python:latest

variables:
    PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"
    
cache:
  paths:
    - .cache/pip
    - venv/

before_script:
  - python --version
  - python -m venv venv
  - source venv/bin/activate
  - pip install -r requirements.txt

stages:
  - prepare
  - test
  - deploy
   

prepare:
    stage: prepare
    script: 
      - echo Done
    
test_app:
    stage: test
    script: 
      - pip list
      - pytest --junitxml=report.xml
    except:
      - schedules
    artifacts:
      when: always
      reports:
        junit: report.xml
        
deploy:
    stage: deploy
    only:
      - master
    except:
      - schedules
    script:
      - echo Deply

job:on-schedule:
    only: 
      - schedules
    script:
      - pytest test_world.py --junitxml=report.xml
    artifacts:
      when: always
      reports:
        junit: report.xml
